/*********************************************************
  equi.c
  --------------------------------------------------------
  generated at Wed Jan 28 13:26:26 2004
  by snns2c ( Bernward Kett 1995 ) 
*********************************************************/

#include <math.h>

#define Act_Logistic(sum, bias)  ( (sum+bias<10000.0) ? ( 1.0/(1.0 + exp(-sum-bias) ) ) : 0.0 )
#ifndef NULL
#define NULL (void *)0
#endif

typedef struct UT {
          float act;         /* Activation       */
          float Bias;        /* Bias of the Unit */
          int   NoOfSources; /* Number of predecessor units */
   struct UT   **sources; /* predecessor units */
          float *weights; /* weights from predecessor units */
        } UnitType, *pUnit;

  /* Forward Declaration for all unit types */
  static UnitType Units[20];
  /* Sources definition section */
  static pUnit Sources[] =  {
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, 
Units + 9, Units + 10, Units + 11, 
Units + 9, Units + 10, Units + 11, 
Units + 9, Units + 10, Units + 11, 
Units + 9, Units + 10, Units + 11, 
Units + 9, Units + 10, Units + 11, 
Units + 9, Units + 10, Units + 11, 
Units + 9, Units + 10, Units + 11, 
Units + 9, Units + 10, Units + 11, 

  };

  /* Weigths definition section */
  static float Weights[] =  {
4.071670, -4.573020, -1.689690, 3.301570, -1.558080, 2.735940, -0.130620, -4.363290, 
-3.244630, -0.665320, -1.591800, 3.720950, -5.605190, -1.379830, 3.887070, 3.017840, 
1.689870, -3.150720, 5.027200, 3.841250, -0.277320, -3.955570, -3.402740, 1.311650, 
5.555810, -7.372200, 3.390480, 
-8.452990, 0.036370, -7.256600, 
-4.533020, -4.143200, 8.641300, 
3.925760, 4.250780, 3.435310, 
-3.379680, -10.406710, -1.929650, 
5.752050, -3.325490, -7.810590, 
0.653100, 7.447030, -6.710950, 
-6.999580, 5.700040, 2.672150, 

  };

  /* unit definition section (see also UnitType) */
  static UnitType Units[20] = 
  {
    { 0.0, 0.0, 0, NULL , NULL },
    { /* unit 1 (Old: 1) */
      0.0, 0.427170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 2 (Old: 2) */
      0.0, -0.729850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 3 (Old: 3) */
      0.0, -0.351080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 4 (Old: 4) */
      0.0, 0.083020, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 5 (Old: 5) */
      0.0, -0.919270, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 6 (Old: 6) */
      0.0, -0.549350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 7 (Old: 7) */
      0.0, 0.246900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 8 (Old: 8) */
      0.0, 0.542720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 9 (Old: 9) */
      0.0, 0.351110, 8,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 10 (Old: 10) */
      0.0, 0.600090, 8,
       &Sources[8] , 
       &Weights[8] , 
      },
    { /* unit 11 (Old: 11) */
      0.0, -0.488360, 8,
       &Sources[16] , 
       &Weights[16] , 
      },
    { /* unit 12 (Old: 12) */
      0.0, -5.403070, 3,
       &Sources[24] , 
       &Weights[24] , 
      },
    { /* unit 13 (Old: 13) */
      0.0, 2.122330, 3,
       &Sources[27] , 
       &Weights[27] , 
      },
    { /* unit 14 (Old: 14) */
      0.0, -4.442270, 3,
       &Sources[30] , 
       &Weights[30] , 
      },
    { /* unit 15 (Old: 15) */
      0.0, -9.215730, 3,
       &Sources[33] , 
       &Weights[33] , 
      },
    { /* unit 16 (Old: 16) */
      0.0, 3.015750, 3,
       &Sources[36] , 
       &Weights[36] , 
      },
    { /* unit 17 (Old: 17) */
      0.0, -2.210920, 3,
       &Sources[39] , 
       &Weights[39] , 
      },
    { /* unit 18 (Old: 18) */
      0.0, -5.576230, 3,
       &Sources[42] , 
       &Weights[42] , 
      },
    { /* unit 19 (Old: 19) */
      0.0, -5.159780, 3,
       &Sources[45] , 
       &Weights[45] , 
      }

  };



int equival(float *in, float *out, int init)
{
  int member, source;
  float sum;
  enum{OK, Error, Not_Valid};
  pUnit unit;


  /* layer definition section (names & member units) */

  static pUnit Input[8] = {Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8}; /* members */

  static pUnit Hidden1[3] = {Units + 9, Units + 10, Units + 11}; /* members */

  static pUnit Output1[8] = {Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19}; /* members */

  static int Output[8] = {12, 13, 14, 15, 16, 17, 18, 19};

  for(member = 0; member < 8; member++) {
    Input[member]->act = in[member];
  }

  for (member = 0; member < 3; member++) {
    unit = Hidden1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for (member = 0; member < 8; member++) {
    unit = Output1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for(member = 0; member < 8; member++) {
    out[member] = Units[Output[member]].act;
  }

  return(OK);
}
